/*
  Copyright (c) 2008-2009 LordZen

  This file is part of tinycalc.

  tinycalc is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  tinycalc is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with tinycalc.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef LEX_H_INCLUDED
#define LEX_H_INCLUDED

#define LEX_BSIZE 100     //buffer size

//lex token
typedef enum token_enum
{
  EOS,    //end of string token
  DEC,    //decimal number token
  HEX,    //esadecimal number token
  BIN,    //binary number token
  SUM,    //addition token
  SUB,    //subtraction token
  MUL,    //multiply token
  DIV,    //division token
  OPAR,   //open parenthesis token
  CPAR,   //closed parenthesis token
  ERR     //error token
} Token;

//syntax analizator struct
typedef struct lex_impl
{
  char *exp;                //expression
  Token token;              //current token
  char value[LEX_BSIZE];    //value of the current token
  int pos;                  //current position in the expression
} Lex;

Lex * lex_init(char *exp);
Token lex_next_token(Lex *lex);
void lex_free(Lex *lex);

#endif // LEX_H_INCLUDED
