/*
  Copyright (c) 2008-2009 LordZen

  This file is part of tinycalc.

  tinycalc is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  tinycalc is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with tinycalc.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PARSER_H_INCLUDED
#define PARSER_H_INCLUDED

/*
  EBNF grammar for an expresion
  ------------------------------

  <exp> ::= <term> { (<sum> | <sub>) <term> }
  <term> ::= <factor> { (<mul> | <div>) <factor> }
  <factor> ::= <num> | "("<exp>")"
  <num> ::= <decimal> | <binary> | <esadecimal>
  <sum> ::= +
  <sub> ::= -
  <mul> ::= *
  <div> ::= /
  <decimal> ::= { "0" | ... | "9" }
  <binary> ::= ("0b") { "0" | "1" }
  <esadecimal> ::= ("0x") { "0" | ... | "9" | "A" | ... | "F" | "a" | ... | "f" }
*/

/*
  parser bottom-up that use the
  syntax analizator
*/
long parse(Lex *lex);


#endif // PARSER_H_INCLUDED
